<?php

// Sets
ini_set("memory_limit", "64M");
ini_set("error_reporting", "E_ALL & ~E_NOTICE");

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "2.78";

// Includes
if (!@include "../conf/conf.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "Aanval In Setup / Upgrade Mode - Exiting.\n\n";
	exit;
}

// php module checking
$module = "mysql";
if (checkModule("$module") == 0) {
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
	procWrite("C", "----------------------------------------------------\n");
	procWrite("C", ".! Fatal Error: $module module not available.\n");
	procwrite("C", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("C", "You must recompile your php binary (cgi) with $module support.");
	procwrite("C", "This must be corrected before Aanval will operate correctly.\n");
	exit;
}
$module = "pcre";
if (checkModule("$module") == 0) {
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
	procWrite("C", "----------------------------------------------------\n");
	procWrite("C", ".! Fatal Error: $module module not available.\n");
	procwrite("C", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("C", "You must recompile your php binary (cgi) with $module support.");
	procwrite("C", "This must be corrected before Aanval will operate correctly.\n");
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

/*
selectedModuleLoad("DB_MOD");
selectedModuleLoad("EVENT_MOD");
selectedModuleLoad("LICENSE_MOD");
selectedModuleLoad("LOGS_MOD");
selectedModuleLoad("OPS_MOD");
selectedModuleLoad("SENSOR_MOD");
selectedModuleLoad("SESSION_MOD");
selectedModuleLoad("SITE_MOD");
selectedModuleLoad("STATUS_MOD");
*/

// Load Database Connections
$idsDB = new idsDB;

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("C", "RESET");

procWrite("C", "----------------------------------------------------");
procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
procWrite("C", ":: IDS: " . versionText());
procWrite("C", ":: System date & time " . timeDisplay($start, 1));
procWrite("C", ":: Last processing finished " . statusProcessorLastRunDiff("C") . " seconds ago.");
procWrite("C", "----------------------------------------------------\n");

// Hold Check
if (file_exists("$root_path/tmp/holdC.tmp")) {
	procwrite("C", ":: ON HOLD -> Exiting");
	exit;
}

// Index System
indexer();

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorC_lastRun", date("U"));
$objStatus->totalProcessorRunIncrement("C");
$objStatus->saveStatus();

$end = date("U");
$seconds = $end - $start;

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;
if (!$dbOpenCount) $dbOpenCount = 0;
if (!$dbCloseCount) $dbCloseCount = 0;
if (!$dbQueryCount) $dbQueryCount = 0;
if (!$dbFailureCount) $dbFailureCount = 0;

// Include checks
foreach (get_included_files() as $file) {
	$size = $size + filesize($file);
	$cnt++;
}
$fs = humanReadablefilesize($size) . " in $cnt";

// Close Database Connections
$idsDB->close();

// Footer
procWrite("C", "----------------------------------------------------");
procwrite("C", ":: Ops [Set: $opsSetCount Get: $opsGetCount]");
procwrite("C", ":: DB [Open: $dbOpenCount Close: $dbCloseCount]");
procwrite("C", ":: DB [Query: $dbQueryCount Failure: $dbFailureCount]");
procWrite("C", ":: Mem [Used: $fs]");
procWrite("C", ":: Completed in $seconds seconds");
procWrite("C", "----------------------------------------------------");

exit;

?>