<?

function prv_graphs() {
	
	$tab = strip_tags(addslashes(getVar("tab")));
	if (!$tab) $tab = 1;
	
	$out = table4("100%", "center", CHARTS_AND_GRAPHS_HEADING, CHARTS_AND_GRAPHS_HEADING);
	$out .= graphTabView($tab);
	
	if ($tab == 1) {
		$out .= graphTab1();
	} else if ($tab == 2) {
		$out .= graphTab2();
	} else if ($tab == 3) {
		$out .= graphTab3();
	} else if ($tab == 4) {
		$out .= graphTab4();
	}

	return $out;
}

function graphTab1() {
	
    // Sensor View Selector (for all user levels)
	$sensorData = sensorViewSelector("?op=prv_graphs&tab=1");

	$eventsToday = eventsToday();
	$eventsYesterday = eventsYesterday();
	$eventsLastHour = eventsLastHour();
	
	// Template
	$array = array(
		"sensorData" => $sensorData,
		"eventsToday" => $eventsToday,
		"eventsYesterday" => $eventsYesterday,
		"eventsLastHour" => $eventsLastHour
	);
    
	$out .= templateParse("graphTab1", $array);

	return $out;
}

function graphTab2() {
	
    // Sensor View Selector (for all user levels)
	$sensorData = sensorViewSelector("?op=prv_graphs&tab=2");

	// Template
	$array = array(
		"sensorData" => $sensorData,
		"eventsByDay_7" => eventsByDay(7),
		"eventsByDay_14" => eventsByDay(14),
		"eventsByDay_30" => eventsByDay(30)
	);
    
	$out .= templateParse("graphTab2", $array);

	return $out;
}

function graphTab3() {
	
    // Sensor View Selector (for all user levels)
	$sensorData = sensorViewSelector("?op=prv_graphs&tab=3");

	// Template
	$array = array(
		"sensorData" => $sensorData,
		"eventsByDay_60" => eventsByDay(60),
		"eventsByDay_90" => eventsByDay(90),
		"eventsByDay_120" => eventsByDay(120)
	);
    
	$out .= templateParse("graphTab3", $array);

	return $out;
}

function graphTab4() {
	
    // Sensor View Selector (for all user levels)
	$sensorData = sensorViewSelector("?op=prv_graphs&tab=4");

	// Template
	$array = array(
		"sensorData" => $sensorData,
		"eventsByRisk" => eventsByRisk(),
		"eventsBySignature" => eventsBySignature(),
		"eventsByCategory" => eventsByCategory()
	);
    
	$out .= templateParse("graphTab4", $array);

	return $out;
}

function graphTabView($tab) {
	
	if ($tab == 1) $active1 = "class=active";
	if ($tab == 2) $active2 = "class=active";
	if ($tab == 3) $active3 = "class=active";
	if ($tab == 4) $active4 = "class=active";
	
	$out .= "<ul id=tabnav>";
		$out .= "<li><a $active1 href='?op=prv_graphs&tab=1'>Recent Graphs</a></li>";
		$out .= "<li><a $active2 href='?op=prv_graphs&tab=2'>Monthly Graphs</a></li>";
		$out .= "<li><a $active3 href='?op=prv_graphs&tab=3'>Long Term Graphs</a></li>";
#		$out .= "<li><a $active4 href='?op=prv_graphs&tab=4'>Miscellaneous Graphs</a></li>";
	$out .= "</ul><br>";
	
	return $out;
}

function eventsToday() {
    global $ops;

    $epoch = date("U");

    $today = timeDisplay("$epoch", 2);

    $data = scTotalEventsToday_aanval(120);
    
    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalBar1.php?data=$data[0]&title=" . TOTAL . " " . EVENTS . " " . TODAY . " ($today)&labels=$data[1]&type=" . $ops->getOpsVar("siteLicenseMonitor") . "&color=" . $ops->getOpsVar("site_secondaryChartColor") . "&timestamp=$epoch\">";
}

function eventsYesterday() {
    global $ops;

    $epoch = date("U");

    $yesterday = timeDisplay($epoch - 86400, 2);

    $data = scTotalEventsYesterday_aanval(900);

    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalBar1.php?data=$data[0]&title=" . TOTAL . " " . EVENTS . " " . YESTERDAY . " ($yesterday)&labels=$data[1]&type=" . $ops->getOpsVar("siteLicenseMonitor") . "&color=" . $ops->getOpsVar("site_secondaryChartColor") . "&timestamp=$epoch\">";
}

function eventsLastHour() {
    global $ops;

    $epoch = date("U");

	$data = scTotalEventsLastHour_aanval(30);
	
    $int = 2;

    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalBar1.php?data=$data[0]&title=" . TOTAL . " " . EVENTS . " / " . LAST . " " . HOUR . "&labels=$data[1]&labelinterval=$int&type=" . $ops->getOpsVar("siteLicenseMonitor") . "&color=" . $ops->getOpsVar("site_secondaryChartColor") . "&timestamp=$epoch\">";
}

function eventsByDay($num, $size = 1) {
    global $ops;

    /* This function provides a jpGraph image of the total number of events for the given number of days ($num) */
    
	$data = scTotalEventsByDay_aanval(600, $num);

    $epoch = date("U");
	
    if ($num > 120) {
    	$int = 7;
    } else if ($num > 100) {
        $int = 6;
    } else if ($num > 90) {
        $int = 5;
    } else if ($num > 60) {
        $int = 4;
    } else if ($num > 30) {
        $int = 3;
    } else if ($num > 20) {
        $int = 2;
    } else {
        $int = 1;
    }
    
    // If $size == 1 (default) then return regular size
    if ($size == 1) {
    	
    	// Return image
    	return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalBar1.php?data=$data[0]&title=" . TOTAL . " " . EVENTS . " / " . LAST . " $num " . DAYS . "&labels=$data[1]&labelinterval=$int&type=" . $ops->getOpsVar("siteLicenseMonitor") . "&color=" . $ops->getOpsVar("site_secondaryChartColor") . "&timestamp=$epoch\">";
    } else if ($size == 2) {
    	
    	// Return image (smaller)
    	return "<img width=450 border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalBar1.php?data=$data[0]&title=" . TOTAL . " " . EVENTS . " / " . LAST . " $num " . DAYS . "&labels=$data[1]&labelinterval=$int&type=" . $ops->getOpsVar("siteLicenseMonitor") . "&color=" . $ops->getOpsVar("site_secondaryChartColor") . "&timestamp=$epoch\">";
    }
}

function eventsByRisk() {
    global $ops;

    $epoch = date("U");

    $data = scTotalEventsByRisk_aanval(120);

    if (!$data[0]) $data[0] = 1;
    if (!$data[1]) $data[1] = "Data Not Available";
    
    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie3.php?data=$data[0]&titles=$data[1]&name=Total Events / Risk Level&timestamp=$epoch\">";
}

function eventsBySensor() {
    global $ops;

    $epoch = date("U");

    $data = scTotalEventsBySensor_aanval(120);
    
    if (!$data[0]) $data[0] = 1;
    if (!$data[1]) $data[1] = "Data Not Available";

    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie3.php?data=$data[0]&titles=$data[1] ($data[0])&name=Events by Sensor&timestamp=$epoch\">";
}

function eventsByCategory() {
    global $ops;

    $epoch = date("U");

    $data = scTotalEventsByCategory_aanval(120);

    if (!$data[0]) $data[0] = 1;
    if (!$data[1]) $data[1] = "Data Not Available";
    
    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie3.php?data=$data[0]&titles=$data[1]&name=Total Events / Category [Top 10]&timestamp=$epoch\">";
}

function eventsBySignature() {
    global $ops;

    $epoch = date("U");

    $data = scTotalEventsBySignature_aanval(120);

    if (!$data[0]) $data[0] = 1;
    if (!$data[1]) $data[1] = "Data Not Available";
    
    return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie3.php?data=$data[0]&titles=$data[1]&name=Total Events / Signature [Top 10]&timestamp=$epoch\">";
}

function frequentEventsGraph() {
	global $login, $ops;
	
	$epoch = date("U");
	
	$sc = scFrequentEvents_aanval(310);
	
	if (count($sc) >= 15) {
		$num = 15;
	} else {
		$num = count($sc);
	}
	
	for ($i=1;$i<$num;$i++) {
	
		$line = explode("||", $sc[$i]);
		if (strlen($line[1]) >= 30) $line[1] = substr($line[1], 0, 30) . "...";
		
		$data .= "$line[2],";
		$titles .= "$line[1],";
	}

    if (!$data) $data = 1;
    if (!$titles) $titles = "Data not available";
	
	return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie2.php?data=$data&titles=$titles&name=Frequent%20Events&timestamp=$epoch\">";
}


function frequentOffendersGraph() {
	global $login, $ops;
	
	$epoch = date("U");
	
	$sc = scFrequentOffenders_aanval(310);
	
	if (count($sc) >= 15) {
		$num = 15;
	} else {
		$num = count($sc);
	}
	
	for ($i=1;$i<$num;$i++) {
	
		$line = explode("||", $sc[$i]);
		if (strlen($line[1]) >= 30) $line[1] = substr($line[1], 0, 30) . "...";
		
		$data .= "$line[2],";
		$titles .= "$line[0],";
	}
	
    if (!$data) $data = 1;
    if (!$titles) $titles = "Data not available";

	return "<img border=0 src=\"modules/GRAPH_MOD/jpgraph/aanvalPie2.php?data=$data&titles=$titles&name=Frequent%20Offenders&timestamp=$epoch\">";
}


?>
