<?

class indexer {

	function indexRun() {
		global $ops;

		// Process indexes
		$this->processIndexes();
		
		// Check for the rebuilding of indexes
		$this->reprocessIndexCheck();
	}
	
	function processIndexes() {
		global $ops, $idsDB;

		// Retrieve and set max indexing rows per run variable
	    $numRow = $ops->getOpsVar("site_processorIndexRun");
	    if (!$numRow) $numRow = 500;
	    
	    // Display
	    procWrite("C", " . Max Indexes Per Run: $numRow");
	    
	    // Retrieve active data table for indexing
	    $table = $ops->getOpsVar("site_activeDataTable");
	
	    // Instantiate new status object
		$objStatus = new myStatus();
		
		// Load status
		$objStatus->loadStatus();
	
		// Retrieve table id of last indexed record
		$lastIndex = $objStatus->getStatusVar("processor_lastIndex");
	    if (!$lastIndex) $lastIndex = 0;

	    // Display
	    procWrite("C", " . Last Indexed Event ID: $lastIndex");
		
	    // Set Index intensity variable | Check for old version and set accordingly
	    $indexIntensity = "," . ops("indexIntensity") . ",";
	    if (strlen($indexIntensity) < 10) {
	    	ops("indexIntensity", "1,2,3,4,5,6,7,8,9,10,11,12,13,19,20");
	    	$indexIntensity = ",1,2,3,4,5,6,7,8,9,10,11,12,13,19,20,";
	    }
	    
	    // Query for all table row data > than last indexed row
	    $idsQueryA = $idsDB->query("select id, level, module, sensorid, ename, enameid, etypename, etypeid, sip, dip, sport, dport, payload, hdr_seq, hdr_ack, ip_ttl, ip_len, hdr_win, proto, epoch from $table where id > $lastIndex limit $numRow");
	    while (list($id, $level, $module, $sensorid, $ename, $enameid, $etypename, $etypeid, $sip, $dip, $sport, $dport, $data_payload, $hdr_seq, $hdr_ack, $ip_ttl, $ip_len, $hdr_win, $proto, $epoch) = mysql_fetch_row($idsQueryA)) {
	
	    	// Increment counter
	    	$cnt++;
	    	
	    	if (strstr($indexIntensity, ",20,")) {
	        	// Payload processing for indexes
	            if ($dport == 80 || $sport == 80 || $dport == 25 || $sport == 25) {
	
	            	// Check for module type
	    			if ($module == 1) {
	    				
	    				// Decode snort module payloads
		                $payload = strip_tags(packet_payload($data_payload, 3, 1));
	    			} else {
	    				
	    				// Set syslog module payloads
	    				$payload = $data_payload;
	    			}
	            } else {
	            	
	            	// Check for module type
	            	if ($module == 2) {
	            		
	            		// Set syslog module payloads
	            		$payload = $data_payload;
	            	}
	            }
	
	    	}
	    	
			if (strstr($indexIntensity, ",19,")) {
				
				$eventString = "$etypename $ename";
				
			}
			
			if ($eventString || $payload) {
				
	        	// Retrieve words from signature category and signature names
	        	$array1 = split("[^[:alpha:]]+", strtolower("$etypename $ename $payload"));
	
	            // Write words to index
	            $wordIndexArray[$id] = $array1; 
#				$this->writeWordIndex($id, $array1);         
	        
	            // Clean up by clearing previous arrays
	            unset($array1, $eventString, $payload);
	    	}	    	

            $a_ip_len[] = $ip_len;
            $a_hdr_win[] = $hdr_win;
            $a_ip_ttl[] = $ip_ttl;
            $a_hdr_seq[] = $hdr_seq;
            $a_hdr_ack[] = $hdr_ack;	    	
	    	
            $last = $id;
	        
            if (strstr($cnt, "00")) {
                procWrite("C", " . $cnt Rows Indexed");
            }
                    
            $a_id[] = $id;
            $a_sip[] = $sip;
            $a_dip[] = $dip;
            $a_sport[] = $sport;
            $a_dport[] = $dport;
            $a_epoch[] = $epoch;
            $a_proto[] = $proto;
            $a_sensorid[] = $sensorid;
            $a_etypeid[] = $etypeid;
            $a_enameid[] = $enameid;
            $a_etypename[] = $etypename;
            $a_ename[] = $ename;
            $a_level[] = $level;
            $a_module[] = $module;
	    }

	    // If new indexes are to be created, otherwise skip this section
	    if ($cnt) {
	    
			$this->writeWordIndex2($wordIndexArray);         
	    	
            // Write the following fields to indexes
            $this->writeConsoleIndexes($indexIntensity, $a_id, $a_ip_len, $a_hdr_win, $a_ip_ttl, $a_hdr_seq, $a_hdr_ack, $a_sip, $a_dip, $a_sport, $a_dport, $a_epoch, $a_proto, $a_sensorid, $a_etypeid, $a_enameid, $a_level, $a_module, $a_ename, $a_etypename);
		    
	        $objStatus->setStatusVar("processor_lastIndex", $last);
		    $objStatus->saveStatus();
	    } else {

	    	// If no indexing took place, then we will want to run the sanitizer
	    	$this->sanitizeIndexes();
	    	
	    }
	    
#	    print_r($wordIndexArray);
	
	}
	
	function reprocessIndexCheck() {
		global $ops, $idsDB, $login;
		
	    // Check if reprocess of indexes was manually forced via console
	    if ($ops->getOpsVar("indexReprocess") == 1) {

	    	procWrite("C", " . Rebuild of indexes requested");
	    	
		    // Queries for clearing index tables
	    	$idsQueryA = $idsDB->query("truncate table idsReverseIndex");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexText");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSport");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexDport");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSip");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexDip");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexWin");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexTtl");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexLen");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexProto");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexTime");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexAck");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSeq");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSensor");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexCategory");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSignature");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexLevel");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexModule");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSignatureName");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexCategoryName");
	        
			// Instantiate new status object
			$objStatus = new myStatus();
			
			// Load status
			$objStatus->loadStatus();	        
	        
	        // Update status to reflect indexing has been cleared
	        $objStatus->setStatusVar("processor_lastIndex", 0);
		    $objStatus->saveStatus();
		    
		    // Update ops variable to reset manual reprocessing variable
	        $ops->setOpsVar("indexReprocess", 0);
	        
	    	procWrite("C", " . Rebuild of indexes finished");
	        
	    }		
	}
	
	function writeWordIndex2($array) {
		global $idsDB;

		// Create array of lower case words
		foreach ($array as $key => $tmpArray) {
			foreach ($tmpArray as $word) {
				$wordArray[] = $word;
			}
		}
		
		// Remove duplicates
		$wordArray = array_unique($wordArray);
		
		// Write words to database
		foreach ($wordArray as $val) {
	    	$tmpQuery .= " ('$val'),";
		}
		
	    // Strip comma from end if exist
		if (substr($tmpQuery, -1, 1) == ",") $tmpQuery = substr($tmpQuery, 0, -1);
	    
        // Insert text id into index
        $idsQueryA = $idsDB->query("insert ignore into idsReverseIndexText (text) values $tmpQuery");

        unset($tmpQuery);
        
        $cnt = 0;
        
		foreach ($array as $key => $tmpArray) {
			
			$tmpArray = array_unique($tmpArray);
			
			foreach ($tmpArray as $word) {

				if ($textArray[$word]) {
					$textid = $textArray[$word];
				} else {
			        $idsQueryA = $idsDB->query("select id from idsReverseIndexText where text = '$word'");
		    		while (list($t_id) = mysql_fetch_row($idsQueryA)) {
		    			$textid = $t_id;
		    		}

		    		$textArray[$word] = $textid;
				}
			
		    	$tmpQuery .= " ('$key', '$textid'),";
		    	
		    	unset ($textid, $word);
			}
		}        
        
	    // Strip comma from end if exist
		if (substr($tmpQuery, -1, 1) == ",") $tmpQuery = substr($tmpQuery, 0, -1);
	    
        // Insert text id into index
        $idsQueryA = $idsDB->query("insert into idsReverseIndex (loc, id) values $tmpQuery");
	}	
	
	function writeWordIndex($id, $array) {
		global $idsDB;
		
		// Loop through text array and write indexes
	    for ($i=0;$i<count($array);$i++) {
	    
	    	// Change string to lower-case
	    	$text = strtolower($array[$i]);
	    	
	    	if ($text == "of" || $text == "and" || $text == "the" || $text == "to" || $text == "how" || $text == "or") {
	    	
	    		// do nothing
	    		
	    	} else {
			    // Insert text data
#		        $idsQueryA = $idsDB->query("insert into idsReverseIndexText (text) values ('$text')", 0);
	
		        // Get last insert id
		        $idsQueryA = $idsDB->query("select id from idsReverseIndexText where text = '$text'");
	    		while (list($t_id) = mysql_fetch_row($idsQueryA)) {
	    			$textid = $t_id;
	    		}
	    	}
	    	
	    	$tquery .= " ('$id', '$textid'),";
	    	
	    }
	    
	    // Strip comma from end if exist
		if (substr($tquery, -1, 1) == ",") $tquery = substr($tquery, 0, -1);
	    
        // Insert text id into index
        $idsQueryA = $idsDB->query("insert into idsReverseIndex (loc, id) values $tquery");
        
	}
	
	function writeConsoleIndexes($indexIntensity, $id, $ip_len, $hdr_win, $ip_ttl, $hdr_seq, $hdr_ack, $sip, $dip, $sport, $dport, $epoch, $proto, $sensorid, $etypeid, $enameid, $level, $module, $ename, $etypename) {
		
		if (strstr($indexIntensity, ",14,")) $this->writeData("idsReverseIndexWin", $id, $hdr_win);
		if (strstr($indexIntensity, ",15,")) $this->writeData("idsReverseIndexLen", $id, $ip_len);
		if (strstr($indexIntensity, ",16,")) $this->writeData("idsReverseIndexSeq", $id, $hdr_seq);
		if (strstr($indexIntensity, ",17,")) $this->writeData("idsReverseIndexAck", $id, $hdr_ack);
		if (strstr($indexIntensity, ",18,")) $this->writeData("idsReverseIndexTtl", $id, $ip_ttl);
		
		$this->writeData("idsReverseIndexSip", $id, $sip);
		$this->writeData("idsReverseIndexDip", $id, $dip);
		$this->writeData("idsReverseIndexSport", $id, $sport);
		$this->writeData("idsReverseIndexDport", $id, $dport);
		$this->writeData("idsReverseIndexTime", $id, $epoch);
		$this->writeData("idsReverseIndexProto", $id, $proto);
		$this->writeData("idsReverseIndexSensor", $id, $sensorid);
		$this->writeData("idsReverseIndexCategory", $id, $etypeid);
		$this->writeData("idsReverseIndexSignature", $id, $enameid);
		$this->writeData("idsReverseIndexLevel", $id, $level);
		$this->writeData("idsReverseIndexModule", $id, $module);
		$this->writeDataHybrid("idsReverseIndexSignatureName", $id, $ename, $enameid);
		$this->writeDataHybrid("idsReverseIndexCategoryName", $id, $etypename, $etypeid);		
	}
	
	function writeData($table, $id, $array) {
		global $idsDB;
		
	    // Insert indexes
	    for ($i=0;$i<count($array);$i++) {
			$mqi .= " ('$id[$i]', '$array[$i]'),";
	    }
	    // Strip comma from end if exist
		if (substr($mqi, -1, 1) == ",") $mqi = substr($mqi, 0, -1);
	    
        $idsQueryA = $idsDB->query("INSERT INTO $table (loc, data) VALUES $mqi");
	}

	function writeDataHybrid($table, $id, $array1, $array2) {
		global $idsDB;
		
	    // Insert indexes
	    for ($i=0;$i<count($array1);$i++) {
			$mqi .= " ('$id[$i]', '$array1[$i]', '$array2[$i]'),";
	    }
	    // Strip comma from end if exist
		if (substr($mqi, -1, 1) == ",") $mqi = substr($mqi, 0, -1);
	    
        $idsQueryA = $idsDB->query("INSERT INTO $table (loc, data, id) VALUES $mqi");
	}
	
	function sanitizeIndexes() {
		global $idsDB;
		
		$sanRunA = 1500;
		$sanRunB = 250;
		
	    // Random num to choose which sanitizer we run
	    $ran = rand(1,20);
	    
	    if ($ran == 10) {
	    	
			procWrite("C", ".. Sanitizing index-a Started");
	    	
			// Check counts to see if sanitizing is necessary
			$idsQueryA = $idsDB->query("select count(id) from idsMain");
			while (list($t_id) = mysql_fetch_row($idsQueryA)) {
				$totalEvents = $t_id;
			}
			$idsQueryA = $idsDB->query("select count(loc) from idsReverseIndexTime");
			while (list($t_id) = mysql_fetch_row($idsQueryA)) {
				$totalIndex = $t_id;
			}
			if ($totalEvents == $totalIndex) return;
		    
	        // Get random array of locations
	        $idsQueryA = $idsDB->query("select loc from idsReverseIndexTime order by rand() limit $sanRunA");
			while (list($t_loc) = mysql_fetch_row($idsQueryA)) {
				$locArray[] = $t_loc;
			}
	
			// Implode into query compatible string
			$compString = implode(",", $locArray);
			
			// Query to compare ID's
			$idsQueryA = $idsDB->query("select id from idsMain where id in ($compString)");
			while (list($t_id) = @mysql_fetch_row($idsQueryA)) {
				$existArray[] = $t_id;
			}
			
			// Compute difference of arrays for removal	
			$remArray = @array_diff($locArray, $existArray);
			
			// If remove array exists, we do what we are suppose to
			if ($remArray) {
				$cnt = count($remArray);
			
				// Delete events from index
				deleteEventsByArray($remArray);
				
			}
			
			if (!$cnt) $cnt = 0;
			procWrite("C", " . Sanitized $cnt index-a records");
			
	    } else if ($ran == 11) {
	    	
			procWrite("C", ".. Sanitizing index-b Started");
	    	
	        $idsQueryA = $idsDB->query("select id, text from idsReverseIndexText order by rand() limit $sanRunB");
			while (list($t_id, $t_text) = mysql_fetch_row($idsQueryA)) {
				
				if (
					strstr($t_text, "mmm") || 
					strstr($t_text, "asdf") || 
					strstr($t_text, "fbq") || 
					strstr($t_text, "xxxx") || 
					strstr($t_text, "yyyy") || 
					strstr($t_text, "cccc") || 
					strstr($t_text, "fzz") || 
					strstr($t_text, "vzz") || 
					strstr($t_text, "szz") || 
					strstr($t_text, "xnm") || 
					strstr($t_text, "mzn") || 
					strstr($t_text, "nmz") || 
					strstr($t_text, "mzw") || 
					strstr($t_text, "mnv") || 
					strstr($t_text, "xmz") || 
					strstr($t_text, "nzq") || 
					strstr($t_text, "xzy") || 
					strstr($t_text, "hvi") || 
					strstr($t_text, "jmv") || 
					strstr($t_text, "zwx") || 
					strstr($t_text, "jcq")) {

					$cnt++;
					
			        $idsQueryB = $idsDB->query("delete from idsReverseIndexText where id = $t_id");
			        $idsQueryB = $idsDB->query("delete from idsReverseIndex where id = $t_id");
				}
			}
			
			if (!$cnt) $cnt = 0;
			procWrite("C", " . Sanitized $cnt index-b records");
	    	
	    }
	}
}

?>